
;########### SECCION DE DATOS
section .data

;########### SECCION DE TEXTO (PROGRAMA)
section .text

;########### LISTA DE FUNCIONES EXPORTADAS
global complex_sum_z
global packed_complex_sum_z
global product_9_f

;########### DEFINICION DE FUNCIONES
;extern uint32_t complex_sum_z(complex_item *arr, uint32_t arr_length);
;registros: arr[rdi], arr_length[rsi]
complex_sum_z:
	push rbp
	mov rbp, rsp
	xor rax, rax

.cycle:
	add rax, [rdi+24]
	add rdi, 32
	dec rsi
	cmp rsi, 0     ; si longitud = 0 salgo del ciclo
	jne .cycle
	
	pop rbp
	ret
	
;extern uint32_t packed_complex_sum_z(packed_complex_item *arr, uint32_t arr_length);
;registros: arr[?], arr_length[?]
packed_complex_sum_z:
	
	push rbp
	mov rbp, rsp
	xor rax, rax

.cycle:
	add rax, [rdi+20]
	add rdi, 24
	dec rsi
	cmp rsi, 0     ; si longitud = 0 salgo del ciclo
	jne .cycle
	
	pop rbp
	ret


;extern void product_9_f(uint32_t * destination
;, uint32_t x1, float f1, uint32_t x2, float f2, uint32_t x3, float f3, uint32_t x4, float f4
;, uint32_t x5, float f5, uint32_t x6, float f6, uint32_t x7, float f7, uint32_t x8, float f8
;, uint32_t x9, float f9);
;registros y pila: destination[rdi], x1[rsi], f1[xmm0], x2[rdx], f2[xmm1], x3[rcx], f3[xmm2], x4[r8], f4[xmm3]
;	, x5[r9], f5[xmm4], x6[rbp+0x10], f6[xmm5], x7[rbp+0x18], f7[xmm6], x8[rbp+0x20], f8[xmm7],
;	, x9[rbp+0x28], f9[rbp+0x30]
product_9_f:

	;prologo 
	push rbp
	mov rbp, rsp
	
	;convertimos los flotantes de cada registro xmm en doubles
	
	cvtss2sd xmm0, xmm0       ; single precision to double precision float
	cvtss2sd xmm1, xmm1
	cvtss2sd xmm2, xmm2
	cvtss2sd xmm3, xmm3
	cvtss2sd xmm4, xmm4
	cvtss2sd xmm5, xmm5
	cvtss2sd xmm6, xmm6
	cvtss2sd xmm7, xmm7

	

	;multiplicamos los doubles en xmm0 <- xmm0 * xmm1, xmm0 * xmm2 , ...

	mulsd xmm0, xmm1           ; multiplicacion de doubles
	mulsd xmm0, xmm2
	mulsd xmm0, xmm3
	mulsd xmm0, xmm4
	mulsd xmm0, xmm5
	mulsd xmm0, xmm6
	mulsd xmm0, xmm7
	
	cvtss2sd xmm1, [rbp+0x30]  	; xmm1 = double([rbp+0x30] = f9)

	mulsd xmm0, xmm1



	; convertimos los enteros en doubles y los multiplicamos por xmm0. 

	push rsi
	cvtpi2pd xmm1, [rbp-0x08]        ; int to double
	mulsd xmm0, xmm1
	pop rsi

	push rdx
	cvtpi2pd xmm1, [rbp-0x08]
	mulsd xmm0, xmm1
	pop rdx

	push rcx
	cvtpi2pd xmm1, [rbp-0x08]
	mulsd xmm0, xmm1
	pop rcx

	push r8
	cvtpi2pd xmm1, [rbp-0x08]
	mulsd xmm0, xmm1
	pop r8

	push r9
	cvtpi2pd xmm1, [rbp-0x08]
	mulsd xmm0, xmm1
	pop r9

	cvtpi2pd xmm1, [rbp+0x10]
	mulsd xmm0, xmm1
	cvtpi2pd xmm1, [rbp+0x18]
	mulsd xmm0, xmm1
	cvtpi2pd xmm1, [rbp+0x20]
	mulsd xmm0, xmm1
	cvtpi2pd xmm1, [rbp+0x28]
	mulsd xmm0, xmm1

	movsd [rdi], xmm0

	; epilogo
	pop rbp
	ret

