extern malloc
extern free
extern fprintf

section .data
	text db "NULL"

section .text

global strCmp
global strClone
global strDelete
global strPrint
global strLen

; ** String **

; int32_t strCmp(char* a, char* b)
strCmp:
	push rbp
	mov rbp, rsp

.cmpLoop:
	mov al, byte [rsi]
	cmp byte [rdi], al
	jg .rdiMayor
	jl .rsiMayor
	cmp byte [rdi], 0x00
	je .iguales
	inc rdi
	inc rsi
	jmp .cmpLoop

.rdiMayor:
	mov rax, -1
	jmp .end

.rsiMayor:
	mov rax, 1
	jmp .end

.iguales:
	mov rax, 0
	jmp .end

.end:
	pop rbp
	ret

; char* strClone(char* a [rdi])
strClone:
	push rbp
	mov rbp, rsp
	push r12
	push r13
	
	mov r12, rdi  ; ---> r12 = char* a

	call strLen   ; ---> rax = lenght(char* a)

	mov r13, rax  ; ---> r13 = lenght(char* a)

	mov rdi, rax
	inc rdi       ; ---> (ultimo byte)
	call malloc wrt ..plt   ; ---> rax = void* b (posicion 0)
	xor rcx, rcx            ; ---> rcx = 0

.copyLoop:
	cmp rcx, r13   ; ---> comparo rcx con lenght(char* a)
	je .end
	mov dl, byte[r12]
	mov byte [rax + rcx], dl   ; ---> copio byte a byte
	inc rcx
	inc r12
	jmp .copyLoop

.end:
	mov byte [rax + rcx], 0x00
	pop r13
	pop r12
	pop rbp
	
ret



; void strDelete(char* a [rdi])
strDelete:
	push rbp
	mov rbp, rsp
	call free wrt ..plt
	pop rbp
ret

; void strPrint(char* a [rdi], FILE* pFile [rsi])
strPrint:
	
	push rbp
	mov rbp, rsp
	push r12
	push r13

	mov r12, rdi
	mov r13, rsi

	call strLen
	cmp rax, 0x00   ; length(a) = 0? 
	je .printNULL
	jmp .end

.printNULL:
	mov r12, text 	; r12 = "NULL"

.end:
	mov rdi, r13    ; rdi = pFile
	mov rsi, r12    ; rsi = char* a or "NULL"
	xor rax, rax
	call fprintf wrt ..plt

	pop r13
	pop r12
	pop rbp
ret


; uint32_t strLen(char* a)
strLen:
	push rbp
	mov rbp, rsp
	xor rax, rax

.lenLoop:
	cmp byte [rdi], 0x00
	je .end
	inc rax
	inc rdi
	jmp .lenLoop

.end:
	pop rbp
ret

